; Sample 6502 Assembler Program to be used on ct-BASIC terminal FPGA core

	.START AUX_start
	.ROM_AREA $8000, $8FFF
	.OPT	Proc6502, CaseInsensitive

RealWorld	= 1	; luft auch im Simulator wenn = 0
GetRAMsize 	= 0	; RAM-Abfrage bei Start wenn = 1
LCD320		= 0	; Version fr LCD 320 x 240, 40 Zeichen / 20 zeilen

	.INCLUDE "defines_cm.asm"	; HW- und ZeroPage-Belegung

;	*=AUX_start	; freies RAM oberhalb VGA-Text $BD00
	*=$8000		; hier: mitten im BASIC-RAM
		
;######################################################
; CALL $8000 plottet Punkte einer Liste mit Y-Werten, 
; die bei $9000 beginnt und 256 Bytes lang ist
; und verschiebt anschlieend die Liste um 1 Byte
; nach "links", d.h. letzter Wert entfllt,
; neuer Wert kann danach in $90FF geschrieben werden
; fr Flackerfreiheit synchronisiert mit PLOTSYNC-Bit
; Im 6502 Simulator als Code "sample.bin" speichern mit:
; Dateityp "Binary image"
; Options Begin $8000, End $9FFF
; In BASIC laden mit LOAD "sample.bin",$8000
;######################################################

PlotGraph:
VSwaitL:			; wait for PLOTSYNC completed
	BIT 	syncFlgs	; frame generated?
	BVS 	VSwaitL		; ..no, wait for frame end
	JSR	FrameClear
	LDX 	#0
PlotGraphRdy:
	BIT	GDone		; Grafik fertig?
	BPL	PlotGraphRdy
	STX	GraphX
	LDA	#4
	STA	GColorP
	LDA 	TestData1,X		; zu plottende Liste
	STA	GraphY
	STA	GmvTrig+1	; +0=MOVE, 1=POINT, 2=LINE, 3=RECT, 4=FILL
	LDA	#6
	STA	GColorP
	LDA 	TestData2,X		; zu plottende Liste
	STA	GraphY
	STA	GmvTrig+1	; +0=MOVE, 1=POINT, 2=LINE, 3=RECT, 4=FILL
	INX			; nchster Punkt
	BNE	PlotGraphRdy
	
ShiftOneLeft:
; Listen um eine Posistion nach "links" verschieben
	LDX	#0	; 
ShiftLoop:
	LDA	TestData1+1,X
	STA	TestData1,X
	LDA	TestData2+1,X
	STA	TestData2,X
	INX
	BNE 	ShiftLoop
	RTS
	
; neuer Datenpunkt kann jetzt auf $90FF gePOKEd werden, Rest
; wurde um 1 Punkt nach links gerckt


;Hilfsroutinen

FrameClear:
;ein Rechteck in Frame-Gre mit Farbe Null fllen
	LDX	#0
	STX	GraphX
	STX	GraphY
	STX	GcolorP
	STX	GmvTrig		; MOVETO
	DEX
	STX	GraphX		; ist jetzt 255
	LDX	#191
	STX	GraphY
	STX	GflTrig		; FILLRECT
	NOP			; small delay
FrameClearRdy:	
	BIT	GDone		; Grafik fertig?
	BPL	FrameClearRdy
	LDX	#7
	STX	GcolorP
	RTS
	
	
	*=$9000

TestData1:	
; 256 Y-Werte zum Test, knnen mit POKEs berschrieben werden
; hier: Mittlere Linie
	.REPEAT 256
	.BYTE	96
	.ENDR

	*=$9100

TestData2:	
; 256 Y-Werte zum Test, knnen mit POKEs berschrieben werden
; hier: Mittlere Linie
	.REPEAT 256
	.BYTE	96
	.ENDR
	